# coding: utf-8

"""
    Nucleus API

    Nucleus text analytics APIs from SumUp Analytics. Example and documentation: https://github.com/SumUpAnalytics/nucleus-sdk  # noqa: E501

    OpenAPI spec version: v3.0.1
    Contact: info@sumup.ai
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class DatasetModel(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'date_modified': 'datetime',
        'time_range': 'list[datetime]'
    }

    attribute_map = {
        'name': 'name',
        'date_modified': 'date_modified',
        'time_range': 'time_range'
    }

    def __init__(self, name=None, date_modified=None, time_range=None):  # noqa: E501
        """DatasetModel - a model defined in Swagger"""  # noqa: E501

        self._name = None
        self._date_modified = None
        self._time_range = None
        self.discriminator = None

        if name is not None:
            self.name = name
        if date_modified is not None:
            self.date_modified = date_modified
        if time_range is not None:
            self.time_range = time_range

    @property
    def name(self):
        """Gets the name of this DatasetModel.  # noqa: E501

        Unique identifier of the dataset  # noqa: E501

        :return: The name of this DatasetModel.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this DatasetModel.

        Unique identifier of the dataset  # noqa: E501

        :param name: The name of this DatasetModel.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def date_modified(self):
        """Gets the date_modified of this DatasetModel.  # noqa: E501

        Datetime of last insertion or deletion of documents  # noqa: E501

        :return: The date_modified of this DatasetModel.  # noqa: E501
        :rtype: datetime
        """
        return self._date_modified

    @date_modified.setter
    def date_modified(self, date_modified):
        """Sets the date_modified of this DatasetModel.

        Datetime of last insertion or deletion of documents  # noqa: E501

        :param date_modified: The date_modified of this DatasetModel.  # noqa: E501
        :type: datetime
        """

        self._date_modified = date_modified

    @property
    def time_range(self):
        """Gets the time_range of this DatasetModel.  # noqa: E501


        :return: The time_range of this DatasetModel.  # noqa: E501
        :rtype: list[datetime]
        """
        return self._time_range

    @time_range.setter
    def time_range(self, time_range):
        """Sets the time_range of this DatasetModel.


        :param time_range: The time_range of this DatasetModel.  # noqa: E501
        :type: list[datetime]
        """

        self._time_range = time_range

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DatasetModel, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DatasetModel):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
